##Load shared libraries
dyn.load("rMvN.so")
source("rMvN.R")

##export OMP_NUM_THREADS=3

rmvn <- function(mu, Sigma){
  n <- length(mu)

  L <- t(chol(Sigma))##just to keep it consistent with our c function
  as.vector(L%*%rnorm(n) + mu)
}

##try out our r and c functions for generating multivariate normal random numbers

##make a covariance matrix
n <- 100
A <- matrix(rnorm(n*n), n, n)
Sigma <- A%*%t(A)

mu <- rep(0, n)

set.seed(1)
v.r <- rmvn(mu, Sigma)

set.seed(1)
v.c <- c.rmvn(mu, Sigma)

max(abs(v.r-v.c$v))
